##// END OF EJS Templates
Updates due to modifs on raspberryPi /linux github...
vidal -
r774:33d3a3b5ebfc
parent child
Show More
1 NO CONTENT: new file 100644, binary diff hidden
@@ -1,54 +1,54
1 1 #
2 2 # Setup APT repositories
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Install and setup APT proxy configuration
9 9 if [ -z "$APT_PROXY" ] ; then
10 10 install_readonly files/apt/10proxy "${ETC_DIR}/apt/apt.conf.d/10proxy"
11 11 sed -i "s/\"\"/\"${APT_PROXY}\"/" "${ETC_DIR}/apt/apt.conf.d/10proxy"
12 12 fi
13 13
14 14 # Install APT sources.list
15 15 install_readonly files/apt/sources.list "${ETC_DIR}/apt/sources.list"
16 16
17 17 # Use specified APT server and release
18 18 sed -i "s/\/ftp.debian.org\//\/${APT_SERVER}\//" "${ETC_DIR}/apt/sources.list"
19 19
20 #Fix for changing path for security updates in testing
21 if [ "$RELEASE" = "testing" ] ; then
22 sed -i "s,buster\\/updates,testing-security," "${ETC_DIR}/apt/sources.list"
23 sed -i "s/ buster/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
20 #Fix for changing path for security updates in oldstable / buster
21 if [ "$RELEASE" = "oldstable" ] || [ "$RELEASE" = "buster " ] ; then
22 sed -i "s:bullseye-security:${RELEASE}\\/updates:" "${ETC_DIR}/apt/sources.list"
23 sed -i "s:security.debian.org/debian-security:security.debian.org:" "${ETC_DIR}/apt/sources.list"
24 24 fi
25 25
26 26 if [ "$ENABLE_NONFREE" = "true" ] ; then
27 27 sed -i "s,main contrib,main contrib non-free," "${ETC_DIR}/apt/sources.list"
28 28 fi
29 29
30 30 if [ -z "$RELEASE" ] ; then
31 31 # Change release in sources list
32 sed -i "s/ buster/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
32 sed -i "s/ bullseye/ ${RELEASE}/" "${ETC_DIR}/apt/sources.list"
33 33 fi
34 34
35 35 # Upgrade package index and update all installed packages and changed dependencies
36 36 chroot_exec apt-get -qq -y update
37 37 chroot_exec apt-get -qq -y -u dist-upgrade
38 38
39 39 # Install additional packages
40 40 if [ "$APT_INCLUDES_LATE" ] ; then
41 41 chroot_exec apt-get -qq -y install $(echo "$APT_INCLUDES_LATE" |tr , ' ')
42 42 fi
43 43
44 44 # Install Debian custom packages
45 45 if [ -d packages ] ; then
46 46 for package in packages/*.deb ; do
47 47 cp "$package" "${R}"/tmp
48 48 chroot_exec dpkg --unpack /tmp/"$(basename "$package")"
49 49 done
50 50 fi
51 51
52 52 chroot_exec apt-get -qq -y -f install
53 53
54 54 chroot_exec apt-get -qq -y check
@@ -1,8 +1,8
1 deb http://ftp.debian.org/debian buster main contrib
2 #deb-src http://ftp.debian.org/debian buster main contrib
1 deb http://debian.proxad.net/debian/ bullseye main contrib
2 #deb-src http://ftp.debian.org/debian bullseye main contrib
3 3
4 deb http://ftp.debian.org/debian/ buster-updates main contrib
5 #deb-src http://ftp.debian.org/debian/ buster-updates main contrib
4 deb http://debian.proxad.net/debian/ bullseye-updates main contrib
5 #deb-src http://ftp.debian.org/debian/ bullseye-updates main contrib
6 6
7 deb http://security.debian.org/ buster/updates main contrib
8 #deb-src http://security.debian.org/ buster/updates main contrib
7 deb http://security.debian.org/debian-security bullseye-security main contrib
8 #deb-src http://security.debian.org/ bullseye/updates main contrib
@@ -1,122 +1,122
1 1 # This file contains utility functions used by rpi23-gen-image.sh
2 2
3 3 cleanup (){
4 4 set +x
5 5 set +e
6 6
7 7 # Remove exports from nexmon
8 8 unset KERNEL
9 9 unset ARCH
10 10 unset SUBARCH
11 11 unset CCPLUGIN
12 12 unset ZLIBFLATE
13 13 unset Q
14 14 unset NEXMON_SETUP_ENV
15 15 unset HOSTUNAME
16 16 unset PLATFORMUNAME
17 17
18 18 # Identify and kill all processes still using files
19 19 echo "killing processes using mount point ..."
20 20 fuser -k "${R}"
21 21 sleep 3
22 22 fuser -9 -k -v "${R}"
23 23
24 24 # Clean up temporary .password file
25 25 if [ -r ".password" ] ; then
26 26 shred -zu .password
27 27 fi
28 28
29 29 # Clean up all temporary mount points
30 30 echo "removing temporary mount points ..."
31 31 umount -l "${R}/proc" 2> /dev/null
32 32 umount -l "${R}/sys" 2> /dev/null
33 33 umount -l "${R}/dev/pts" 2> /dev/null
34 34 umount "$BUILDDIR/mount/boot/firmware" 2> /dev/null
35 35 umount "$BUILDDIR/mount" 2> /dev/null
36 36 cryptsetup close "${CRYPTFS_MAPPING}" 2> /dev/null
37 37 losetup -d "$ROOT_LOOP" 2> /dev/null
38 38 losetup -d "$FRMW_LOOP" 2> /dev/null
39 39 trap - 0 1 2 3 6
40 40 }
41 41
42 42 chroot_exec() {
43 43 # Exec command in chroot
44 44 LANG=C LC_ALL=C DEBIAN_FRONTEND=noninteractive chroot "${R}" "$@"
45 45 }
46 46
47 47 as_nobody() {
48 48 # Exec command as user nobody
49 49 sudo -E -u nobody LANG=C LC_ALL=C "$@"
50 50 }
51 51
52 52 install_readonly() {
53 53 # Install file with user read-only permissions
54 54 install -o root -g root -m 644 "$@"
55 55 }
56 56
57 57 install_exec() {
58 58 # Install file with root exec permissions
59 59 install -o root -g root -m 744 "$@"
60 60 }
61 61
62 62 use_template () {
63 63 # Test if configuration template file exists
64 64 if [ ! -r "./templates/${CONFIG_TEMPLATE}" ] ; then
65 65 echo "error: configuration template ${CONFIG_TEMPLATE} not found"
66 66 exit 1
67 67 fi
68 68
69 69 # Load template configuration parameters
70 70 . "./templates/${CONFIG_TEMPLATE}"
71 71 }
72 72
73 73 chroot_install_cc() {
74 74 # Install c/c++ build environment inside the chroot
75 75 if [ -z "${COMPILER_PACKAGES}" ] ; then
76 76 COMPILER_PACKAGES=$(chroot_exec apt-get -s install g++ make bc | grep "^Inst " | awk -v ORS=" " '{ print $2 }')
77 77
78 78
79 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] || [ "$RELEASE" = "bullseye" ] ; then
79 if [ "$RELEASE" = "bookworm" ] || [ "$RELEASE" = "buster" ] || [ "$RELEASE" = "bullseye" ] ; then
80 80 chroot_exec apt-get -q -y --no-install-recommends install ${COMPILER_PACKAGES}
81 elif [ "$RELEASE" = "buster" ] || [ "$RELEASE" = "bullseye" ] ; then
81 elif [ "$RELEASE" = "buster" ] || [ "$RELEASE" = "bullseye" ] || [ "$RELEASE" = "bookworm" ]; then
82 82 chroot_exec apt-get -q -y --allow-unauthenticated --no-install-recommends install ${COMPILER_PACKAGES}
83 83 fi
84 84
85 85 fi
86 86 }
87 87
88 88 chroot_remove_cc() {
89 89 # Remove c/c++ build environment from the chroot
90 90 if [ -n "${COMPILER_PACKAGES}" ] ; then
91 91 chroot_exec apt-get -qq -y --auto-remove purge ${COMPILER_PACKAGES}
92 92 COMPILER_PACKAGES=""
93 93 fi
94 94 }
95 95
96 96 # https://serverfault.com/a/682849 - converts e.g. /24 to 255.255.255.0
97 97 cdr2mask ()
98 98 {
99 99 # Number of args to shift, 255..255, first non-255 byte, zeroes
100 100 set -- $(( 5 - ($1 / 8) )) 255 255 255 255 $(( (255 << (8 - ($1 % 8))) & 255 )) 0 0 0
101 101 [ $1 -gt 1 ] && shift $1 || shift
102 102 echo ${1-0}.${2-0}.${3-0}.${4-0}
103 103 }
104 104
105 105 # GPL v2.0 - #https://github.com/sakaki-/bcmrpi3-kernel-bis/blob/master/conform_config.sh
106 106 set_kernel_config() {
107 107 # flag as $1, value to set as $2, config must exist at "./.config"
108 108 TGT="CONFIG_${1#CONFIG_}"
109 109 REP="${2}"
110 110 if grep -q "^${TGT}[^_]" .config; then
111 111 sed -i "s/^\(${TGT}=.*\|# ${TGT} is not set\)/${TGT}=${REP}/" .config
112 112 else
113 113 echo "${TGT}"="${2}" >> .config
114 114 fi
115 115 }
116 116
117 117 # unset kernel config parameter
118 118 unset_kernel_config() {
119 119 # unsets flag with the value of $1, config must exist at "./.config"
120 120 TGT="CONFIG_${1#CONFIG_}"
121 121 sed -i "s/^${TGT}=.*/# ${TGT} is not set/" .config
122 122 }
@@ -1,924 +1,926
1 1 #!/bin/bash
2 2 ########################################################################
3 3 # rpi23-gen-image.sh 2015-2017
4 4 #
5 # Advanced Debian "buster" and "bullseye" bootstrap script for Raspberry Pi
5 # Advanced Debian "bullseye" and "bookworm" bootstrap script for Raspberry Pi
6 6 #
7 7 # This program is free software; you can redistribute it and/or
8 8 # modify it under the terms of the GNU General Public License
9 9 # as published by the Free Software Foundation; either version 2
10 10 # of the License, or (at your option) any later version.
11 11 #
12 12 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
13 13 #
14 14 # Big thanks for patches and enhancements by 20+ github contributors!
15 15 ########################################################################
16 16
17 17 # Are we running as root?
18 18 if [ "$(id -u)" -ne "0" ] ; then
19 19 echo "error: this script must be executed with root privileges!"
20 20 exit 1
21 21 fi
22 22
23 23 # Check if ./functions.sh script exists
24 24 if [ ! -r "./functions.sh" ] ; then
25 25 echo "error: './functions.sh' required script not found!"
26 26 exit 1
27 27 fi
28 28
29 29 # Load utility functions
30 30 . ./functions.sh
31 31
32 32 # Load parameters from configuration template file
33 33 if [ -n "$CONFIG_TEMPLATE" ] ; then
34 34 use_template
35 35 fi
36 36
37 37 # Introduce settings
38 38 set -e
39 39 echo -n -e "\n#\n# RPi 0/1/2/3/4 Bootstrap Settings\n#\n"
40 40 set -x
41 41
42 # Raspberry Pi model configuration
42 # Raspberry Pi model configuration defaults to 3P
43 43 RPI_MODEL=${RPI_MODEL:=3P}
44 44
45 # Debian release
46 RELEASE=${RELEASE:=buster}
47 if [ $RELEASE = "bullseye" ] ; then
45 # Debian release defaults to bullseye
46 RELEASE=${RELEASE:=bullseye}
47 if [ "$RELEASE" = "bookworm" ] ; then
48 48 RELEASE=testing
49 49 fi
50 echo "Debian release value used : " $RELEASE
50 51
51 52 # Kernel Branch
52 53 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
53 54
54 55 # URLs
55 56 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
56 57 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
57 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
58 #WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
59 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://raw.githubusercontent.com/RPi-Distro/firmware-nonfree/bullseye/debian/config/brcm80211/brcm}
58 60 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
59 61 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
60 62 VIDEOCORE_URL=${VIDEOCORE_URL:=https://github.com/raspberrypi/userland}
61 63 BLUETOOTH_URL=${BLUETOOTH_URL:=https://github.com/RPi-Distro/pi-bluetooth.git}
62 64 NEXMON_URL=${NEXMON_URL:=https://github.com/seemoo-lab/nexmon.git}
63 65 SYSTEMDSWAP_URL=${SYSTEMDSWAP_URL:=https://github.com/Nefelim4ag/systemd-swap.git}
64 66
65 67 # Kernel deb packages for 32bit kernel
66 68 RPI_32_KERNEL_URL=${RPI_32_KERNEL_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel_20180422-141901_armhf.deb}
67 69 RPI_32_KERNELHEADER_URL=${RPI_32_KERNELHEADER_URL:=https://github.com/hypriot/rpi-kernel/releases/download/v4.14.34/raspberrypi-kernel-headers_20180422-141901_armhf.deb}
68 70 # Kernel has KVM and zswap enabled - use if KERNEL_* parameters and precompiled kernel are used
69 71 RPI3_64_BIS_KERNEL_URL=${RPI3_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel-bis/releases/download/4.19.102.20200211/bcmrpi3-kernel-bis-4.19.102.20200211.tar.xz}
70 72 # Default precompiled 64bit kernel
71 73 RPI3_64_DEF_KERNEL_URL=${RPI3_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcmrpi3-kernel/releases/download/4.19.102.20200211/bcmrpi3-kernel-4.19.102.20200211.tar.xz}
72 74 # Sakaki BIS Kernel RPI4 - https://github.com/sakaki-/bcm2711-kernel-bis
73 75 RPI4_64_BIS_KERNEL_URL=${RPI4_64_BIS_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
74 76 # Default precompiled 64bit kernel - https://github.com/sakaki-/bcm2711-kernel
75 77 RPI4_64_DEF_KERNEL_URL=${RPI4_64_DEF_KERNEL_URL:=https://github.com/sakaki-/bcm2711-kernel-bis/releases/download/4.19.102.20200211/bcm2711-kernel-bis-4.19.102.20200211.tar.xz}
76 78 # Generic
77 79 RPI3_64_KERNEL_URL=${RPI3_64_KERNEL_URL:=$RPI3_64_DEF_KERNEL_URL}
78 80 RPI4_64_KERNEL_URL=${RPI4_64_KERNEL_URL:=$RPI4_64_DEF_KERNEL_URL}
79 81 # Kali kernel src - used if ENABLE_NEXMON=true (they patch the wlan kernel modul)
80 82 KALI_KERNEL_URL=${KALI_KERNEL_URL:=https://github.com/Re4son/re4son-raspberrypi-linux.git}
81 83
82 84 # Build directories
83 85 WORKDIR=$(pwd)
84 86 BASEDIR=${BASEDIR:=${WORKDIR}/images/${RELEASE}}
85 87 BUILDDIR="${BASEDIR}/build"
86 88
87 89 # Chroot directories
88 90 R="${BUILDDIR}/chroot"
89 91 ETC_DIR="${R}/etc"
90 92 LIB_DIR="${R}/lib"
91 93 BOOT_DIR="${R}/boot/firmware"
92 94 KERNEL_DIR="${R}/usr/src/linux"
93 95 WLAN_FIRMWARE_DIR="${LIB_DIR}/firmware/brcm"
94 96 BLUETOOTH_FIRMWARE_DIR="${ETC_DIR}/firmware/bt"
95 97
96 98 # APT settings
97 99 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
98 100 APT_PROXY=${APT_PROXY:=""}
99 101 KEEP_APT_PROXY=${KEEP_APT_PROXY:=false}
100 102 # Packages required in the chroot build environment
101 103 APT_INCLUDES=${APT_INCLUDES:=""}
102 104 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils,locales,keyboard-configuration,console-setup,libnss-systemd"
103 105 # Packages to exclude from chroot build environment
104 106 APT_EXCLUDES=${APT_EXCLUDES:=""}
105 107
106 108 # General settings
107 109 SET_ARCH=${SET_ARCH:=32}
108 110 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
109 111 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
110 112 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
111 113 EXPANDROOT=${EXPANDROOT:=true}
112 114
113 115 ENABLE_ROOT=${ENABLE_ROOT:=false}
114 116 ROOT_PASSWORD=${ROOT_PASSWORD:=raspberry}
115 117 ENABLE_USER=${ENABLE_USER:=true}
116 118 USER_NAME=${USER_NAME:="pi"}
117 119 USER_PASSWORD=${USER_PASSWORD:=raspberry}
118 120
119 121 # Keyboard settings
120 122 XKB_MODEL=${XKB_MODEL:=""}
121 123 XKB_LAYOUT=${XKB_LAYOUT:=""}
122 124 XKB_VARIANT=${XKB_VARIANT:=""}
123 125 XKB_OPTIONS=${XKB_OPTIONS:=""}
124 126
125 127 # Networking settings:
126 128 ENABLE_IPV6=${ENABLE_IPV6:=true}
127 129 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
128 130 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
129 131 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
130 132 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
131 133
132 134 # Network settings (DHCP)
133 135 ENABLE_ETH_DHCP=${ENABLE_ETH_DHCP:=true}
134 136 ENABLE_WIFI_DHCP=${ENABLE_ETH_DHCP:=true}
135 137
136 138 # Network settings (static)
137 139 NET_ETH_ADDRESS=${NET_ETH_ADDRESS:=""}
138 140 NET_ETH_GATEWAY=${NET_ETH_GATEWAY:=""}
139 141 NET_ETH_DNS_1=${NET_ETH_DNS_1:=""}
140 142 NET_ETH_DNS_2=${NET_ETH_DNS_2:=""}
141 143 NET_ETH_DNS_DOMAINS=${NET_ETH_DNS_DOMAINS:=""}
142 144 NET_ETH_NTP_1=${NET_ETH_NTP_1:=""}
143 145 NET_ETH_NTP_2=${NET_ETH_NTP_2:=""}
144 146
145 147 # Networking settings (WIFI):
146 148 NET_WIFI_SSID=${NET_WIFI_SSID:=""}
147 149 NET_WIFI_PSK=${NET_WIFI_PSK:=""}
148 150
149 151 # Network settings (static)
150 152 NET_WIFI_ADDRESS=${NET_WIFI_ADDRESS:=""}
151 153 NET_WIFI_GATEWAY=${NET_WIFI_GATEWAY:=""}
152 154 NET_WIFI_DNS_1=${NET_WIFI_DNS_1:=""}
153 155 NET_WIFI_DNS_2=${NET_WIFI_DNS_2:=""}
154 156 NET_WIFI_DNS_DOMAINS=${NET_WIFI_DNS_DOMAINS:=""}
155 157 NET_WIFI_NTP_1=${NET_WIFI_NTP_1:=""}
156 158 NET_WIFI_NTP_2=${NET_WIFI_NTP_2:=""}
157 159
158 160 # Feature settings
159 161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=false}
160 162 ENABLE_PRINTK=${ENABLE_PRINTK:=false}
161 163 ENABLE_BLUETOOTH=${ENABLE_BLUETOOTH:=false}
162 164 ENABLE_MINIUART_OVERLAY=${ENABLE_MINIUART_OVERLAY:=false}
163 165 ENABLE_TURBO=${ENABLE_TURBO:=false}
164 166 ENABLE_I2C=${ENABLE_I2C:=false}
165 167 ENABLE_SPI=${ENABLE_SPI:=false}
166 168
167 169 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
168 170 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
169 171 ENABLE_SOUND=${ENABLE_SOUND:=false}
170 172 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 173 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 174 ENABLE_XORG=${ENABLE_XORG:=false}
173 175 ENABLE_WM=${ENABLE_WM:=""}
174 176 ENABLE_SYSVINIT=${ENABLE_SYSVINIT:=false}
175 177 ENABLE_SPLASH=${ENABLE_SPLASH:=true}
176 178 ENABLE_LOGO=${ENABLE_LOGO:=true}
177 179 ENABLE_SILENT_BOOT=${ENABLE_SILENT_BOOT=false}
178 180 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
179 181
180 182 # Advanced settings
181 183 ENABLE_DPHYSSWAP=${ENABLE_DPHYSSWAP:=true}
182 184 ENABLE_SYSTEMDSWAP=${ENABLE_SYSTEMDSWAP:=false}
183 185 ENABLE_QEMU=${ENABLE_QEMU:=false}
184 186 ENABLE_KEYGEN=${ENABLE_KEYGEN:=false}
185 187 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
186 188 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
187 189 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
188 190 ENABLE_DBUS=${ENABLE_DBUS:=true}
189 191 ENABLE_USBBOOT=${ENABLE_USBBOOT=false}
190 192 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
191 193 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
192 194 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
193 195 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
194 196 ENABLE_GR_ACCEL=${ENABLE_GR_ACCEL:=true}
195 197 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
196 198 ENABLE_VIDEOCORE=${ENABLE_VIDEOCORE:=false}
197 199 VIDEOCORESRC_DIR=${VIDEOCORESRC_DIR:=""}
198 200 ENABLE_NEXMON=${ENABLE_NEXMON:=false}
199 201 NEXMONSRC_DIR=${NEXMONSRC_DIR:=""}
200 202
201 203 # SSH settings
202 204 SSH_ENABLE=${SSH_ENABLE:=true}
203 205 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
204 206 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
205 207 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
206 208 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
207 209 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
208 210
209 211 # Kernel compilation settings
210 212 BUILD_KERNEL=${BUILD_KERNEL:=true}
211 213 KERNEL_THREADS=${KERNEL_THREADS:=1}
212 214 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
213 215 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
214 216 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
215 217 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
216 218 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
217 219 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
218 220 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
219 221 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
220 222 KERNELSRC_USRCONFIG=${KERNELSRC_USRCONFIG:=""}
221 223 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
222 224 # Firmware directory: Blank if download from github
223 225 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
224 226 KERNEL_DEFAULT_GOV=${KERNEL_DEFAULT_GOV:=ondemand}
225 227 KERNEL_NF=${KERNEL_NF:=false}
226 228 KERNEL_VIRT=${KERNEL_VIRT:=false}
227 229 KERNEL_ZSWAP=${KERNEL_ZSWAP:=false}
228 230 KERNEL_BPF=${KERNEL_BPF:=false}
229 231 KERNEL_SECURITY=${KERNEL_SECURITY:=false}
230 232 KERNEL_BTRFS=${KERNEL_BTRFS:=false}
231 233 KERNEL_POEHAT=${KERNEL_POEHAT:=false}
232 234 KERNEL_NSPAN=${KERNEL_NSPAN:=false}
233 235 KERNEL_DHKEY=${KERNEL_DHKEY:=true}
234 236
235 237 # Reduce disk usage settings
236 238 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
237 239 REDUCE_APT=${REDUCE_APT:=true}
238 240 REDUCE_DOC=${REDUCE_DOC:=false}
239 241 REDUCE_MAN=${REDUCE_MAN:=false}
240 242 REDUCE_VIM=${REDUCE_VIM:=false}
241 243 REDUCE_BASH=${REDUCE_BASH:=false}
242 244 REDUCE_HWDB=${REDUCE_HWDB:=false}
243 245 REDUCE_SSHD=${REDUCE_SSHD:=false}
244 246 REDUCE_LOCALE=${REDUCE_LOCALE:=false}
245 247 REDUCE_KERNEL=${REDUCE_KERNEL:=false}
246 248
247 249 # Encrypted filesystem settings
248 250 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
249 251 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
250 252 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
251 253 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64"}
252 254 CRYPTFS_HASH=${CRYPTFS_HASH:="sha256"}
253 255 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=256}
254 256 #Dropbear-initramfs supports unlocking encrypted filesystem via SSH on bootup
255 257 CRYPTFS_DROPBEAR=${CRYPTFS_DROPBEAR:=false}
256 258 #Provide your own Dropbear Public RSA-OpenSSH Key otherwise it will be generated
257 259 CRYPTFS_DROPBEAR_PUBKEY=${CRYPTFS_DROPBEAR_PUBKEY:=""}
258 260
259 261 # Packages required for bootstrapping
260 262 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus bison flex libssl-dev sudo"
261 263 MISSING_PACKAGES=""
262 264
263 265 # Packages installed for c/c++ build environment in chroot (keep empty)
264 266 COMPILER_PACKAGES=""
265 267
266 268 # Check if apt-cacher-ng has port 3142 open and set APT_PROXY
267 269 APT_CACHER_RUNNING=$(lsof -i :3142 | cut -d ' ' -f3 | uniq | sed '/^\s*$/d')
268 270 if [ "${APT_CACHER_RUNNING}" = "apt-cacher-ng" ] ; then
269 271 APT_PROXY=http://127.0.0.1:3142/
270 272 fi
271 273
272 274 # Setup architecture specific settings
273 275 if [ -n "$SET_ARCH" ] ; then
274 276 ## 64-bit configuration
275 277 if [ "$SET_ARCH" = 64 ] ; then
276 278 ### General 64-bit depended settings
277 279 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
278 280 KERNEL_ARCH=${KERNEL_ARCH:=arm64}
279 281 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
280 282
281 283 ### Raspberry Pi model specific settings
282 284 if [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
283 285 if [ "$RPI_MODEL" != 4 ] ; then
284 286 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
285 287 else
286 288 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
287 289 fi
288 290
289 291 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
290 292 RELEASE_ARCH=${RELEASE_ARCH:=arm64}
291 293 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
292 294 CROSS_COMPILE=${CROSS_COMPILE:=aarch64-linux-gnu-}
293 295
294 296 else
295 297 echo "error: Only Raspberry PI 3, 3B+ and 4 support 64-bit"
296 298 exit 1
297 299 fi
298 300 fi
299 301
300 302 ## 32-bit configuration
301 303 if [ "$SET_ARCH" = 32 ] ; then
302 304 ### General 32-bit dependend settings
303 305 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
304 306 KERNEL_ARCH=${KERNEL_ARCH:=arm}
305 307 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
306 308
307 309 ### Raspberry Pi (0-1P) model specific settings
308 310 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
309 311 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armel"
310 312 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
311 313 RELEASE_ARCH=${RELEASE_ARCH:=armel}
312 314 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel.img}
313 315 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabi-}
314 316
315 317 if [ $ENABLE_XORG = true ] ; then
316 318 if [$RELEASE = "stretch" ] || [$RELEASE = "oldstable" ] ; then
317 319 printf "\nBest support for armel architecture is provided under Debian stretch/oldstable. Choose yes to change release to Debian stretch[y/n] "
318 320 read -r confirm
319 321 if [ "$confirm" = "y" ] ; then
320 322 $RELEASE = "stretch"
321 323 fi
322 324 fi
323 325 fi
324 326 fi
325 327 ### Raspberry Pi (2-4) model specific settings
326 328 if [ "$RPI_MODEL" = 2 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
327 329 if [ "$RPI_MODEL" != 4 ] ; then
328 330 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
329 331 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
330 332 else
331 333 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2711_defconfig}
332 334 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7l.img}
333 335 fi
334 336
335 337 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
336 338 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
337 339
338 340 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
339 341 fi
340 342 fi
341 343 # SET_ARCH not set
342 344 else
343 345 echo "error: Please set '32' or '64' as value for SET_ARCH"
344 346 exit 1
345 347 fi
346 348 # Device specific configuration and U-Boot configuration
347 349 case "$RPI_MODEL" in
348 350 0)
349 351 DTB_FILE=${DTB_FILE:=bcm2708-rpi-0-w.dtb}
350 352 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
351 353 ;;
352 354 1)
353 355 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b.dtb}
354 356 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
355 357 ;;
356 358 1P)
357 359 DTB_FILE=${DTB_FILE:=bcm2708-rpi-b-plus.dtb}
358 360 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_defconfig}
359 361 ;;
360 362 2)
361 363 DTB_FILE=${DTB_FILE:=bcm2709-rpi-2-b.dtb}
362 364 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_2_defconfig}
363 365 ;;
364 366 3)
365 367 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
366 368 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
367 369 ;;
368 370 3P)
369 371 DTB_FILE=${DTB_FILE:=bcm2710-rpi-3-b.dtb}
370 372 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_3_defconfig}
371 373 ;;
372 374 4)
373 375 DTB_FILE=${DTB_FILE:=bcm2711-rpi-4-b.dtb}
374 376 UBOOT_CONFIG=${UBOOT_CONFIG:=rpi_4_defconfig}
375 377 ;;
376 378 *)
377 379 echo "error: Raspberry Pi model $RPI_MODEL is not supported!"
378 380 exit 1
379 381 ;;
380 382 esac
381 383
382 384 # Raspberry PI 0,3,3P,4 with Bluetooth and Wifi onboard
383 385 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 3 ] || [ "$RPI_MODEL" = 3P ] || [ "$RPI_MODEL" = 4 ] ; then
384 386 ## Include bluetooth packages on supported boards
385 387 if [ "$ENABLE_BLUETOOTH" = true ] ; then
386 388 APT_INCLUDES="${APT_INCLUDES},bluetooth,bluez"
387 389 fi
388 390 if [ "$ENABLE_WIRELESS" = true ] ; then
389 391 APT_INCLUDES="${APT_INCLUDES},wireless-tools,crda,wireless-regdb,wpasupplicant"
390 392 fi
391 393 # Raspberry PI 1,1P,2 without Wifi and bluetooth onboard
392 394 else
393 395 ## Check if the internal wireless interface is not supported by the RPi model
394 396 if [ "$ENABLE_WIRELESS" = true ] || [ "$ENABLE_BLUETOOTH" = true ]; then
395 397 echo "error: The selected Raspberry Pi model has no integrated interface for wireless or bluetooth"
396 398 exit 1
397 399 fi
398 400 fi
399 401
400 402 if [ "$BUILD_KERNEL" = false ] && [ "$ENABLE_NEXMON" = true ]; then
401 403 echo "error: You have to compile kernel sources, if you want to enable nexmon"
402 404 exit 1
403 405 fi
404 406
405 407 # Prepare date string for default image file name
406 408 DATE="$(date +%Y-%m-%d)"
407 409 if [ -z "$KERNEL_BRANCH" ] ; then
408 410 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
409 411 else
410 412 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
411 413 fi
412 414
413 415 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
414 416 if [ -n "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
415 417 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
416 418 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
417 419 exit 1
418 420 fi
419 421 fi
420 422
421 423 # Add cmake to compile videocore sources
422 424 if [ "$ENABLE_VIDEOCORE" = true ] ; then
423 425 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cmake"
424 426 fi
425 427
426 428 # Add deps for nexmon
427 429 if [ "$ENABLE_NEXMON" = true ] ; then
428 430 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libgmp3-dev gawk qpdf make autoconf automake build-essential libtool"
429 431 fi
430 432
431 433 # Add libncurses5 to enable kernel menuconfig
432 434 if [ "$KERNEL_MENUCONFIG" = true ] ; then
433 435 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses-dev"
434 436 fi
435 437
436 438 # Add ccache compiler cache for (faster) kernel cross (re)compilation
437 439 if [ "$KERNEL_CCACHE" = true ] ; then
438 440 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
439 441 fi
440 442
441 443 # Add cryptsetup package to enable filesystem encryption
442 444 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
443 445 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
444 446 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup,cryptsetup-initramfs"
445 447
446 448 # If cryptfs,dropbear and initramfs are enabled include dropbear-initramfs package
447 449 if [ "$CRYPTFS_DROPBEAR" = true ] && [ "$ENABLE_INITRAMFS" = true ]; then
448 450 APT_INCLUDES="${APT_INCLUDES},dropbear-initramfs"
449 451 fi
450 452
451 453 if [ -z "$CRYPTFS_PASSWORD" ] ; then
452 454 echo "error: no password defined (CRYPTFS_PASSWORD)!"
453 455 exit 1
454 456 fi
455 457 ENABLE_INITRAMFS=true
456 458 fi
457 459
458 460 # Add initramfs generation tools
459 461 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
460 462 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
461 463 fi
462 464
463 465 # Add device-tree-compiler required for building the U-Boot bootloader
464 466 if [ "$ENABLE_UBOOT" = true ] ; then
465 467 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bc"
466 468 fi
467 469
468 470 if [ "$ENABLE_USBBOOT" = true ] ; then
469 471 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1P ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 2 ]; then
470 472 echo "error: Booting from USB alone is only supported by Raspberry Pi 3 and 3P"
471 473 exit 1
472 474 fi
473 475 fi
474 476
475 477 # Check if root SSH (v2) public key file exists
476 478 if [ -n "$SSH_ROOT_PUB_KEY" ] ; then
477 479 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
478 480 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
479 481 exit 1
480 482 fi
481 483 fi
482 484
483 485 # Check if $USER_NAME SSH (v2) public key file exists
484 486 if [ -n "$SSH_USER_PUB_KEY" ] ; then
485 487 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
486 488 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
487 489 exit 1
488 490 fi
489 491 fi
490 492
491 493 if [ "$ENABLE_NEXMON" = true ] && [ -n "$KERNEL_BRANCH" ] ; then
492 494 echo "error: Please unset KERNEL_BRANCH if using ENABLE_NEXMON"
493 495 exit 1
494 496 fi
495 497
496 498 # Check if all required packages are installed on the build system
497 499 for package in $REQUIRED_PACKAGES ; do
498 500 if [ "$(dpkg-query -W -f='${Status}' "$package")" != "install ok installed" ] ; then
499 501 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
500 502 fi
501 503 done
502 504
503 505 # If there are missing packages ask confirmation for install, or exit
504 506 if [ -n "$MISSING_PACKAGES" ] ; then
505 507 echo "the following packages needed by this script are not installed:"
506 508 echo "$MISSING_PACKAGES"
507 509
508 510 printf "\ndo you want to install the missing packages right now? [y/n] "
509 511 read -r confirm
510 512 [ "$confirm" != "y" ] && exit 1
511 513
512 514 ## Make sure all missing required packages are installed
513 515 apt-get update && apt-get -qq -y install `echo "${MISSING_PACKAGES}" | sed "s/ //"`
514 516 fi
515 517
516 518 # Check if ./bootstrap.d directory exists
517 519 if [ ! -d "./bootstrap.d/" ] ; then
518 520 echo "error: './bootstrap.d' required directory not found!"
519 521 exit 1
520 522 fi
521 523
522 524 # Check if ./files directory exists
523 525 if [ ! -d "./files/" ] ; then
524 526 echo "error: './files' required directory not found!"
525 527 exit 1
526 528 fi
527 529
528 530 # Check if specified KERNELSRC_DIR directory exists
529 531 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
530 532 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
531 533 exit 1
532 534 fi
533 535
534 536 # Check if specified UBOOTSRC_DIR directory exists
535 537 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
536 538 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
537 539 exit 1
538 540 fi
539 541
540 542 # Check if specified VIDEOCORESRC_DIR directory exists
541 543 if [ -n "$VIDEOCORESRC_DIR" ] && [ ! -d "$VIDEOCORESRC_DIR" ] ; then
542 544 echo "error: '${VIDEOCORESRC_DIR}' specified directory not found (VIDEOCORESRC_DIR)!"
543 545 exit 1
544 546 fi
545 547
546 548 # Check if specified FBTURBOSRC_DIR directory exists
547 549 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
548 550 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
549 551 exit 1
550 552 fi
551 553
552 554 # Check if specified NEXMONSRC_DIR directory exists
553 555 if [ -n "$NEXMONSRC_DIR" ] && [ ! -d "$NEXMONSRC_DIR" ] ; then
554 556 echo "error: '${NEXMONSRC_DIR}' specified directory not found (NEXMONSRC_DIR)!"
555 557 exit 1
556 558 fi
557 559
558 560 # Check if specified CHROOT_SCRIPTS directory exists
559 561 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
560 562 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
561 563 exit 1
562 564 fi
563 565
564 566 # Check if specified device mapping already exists (will be used by cryptsetup)
565 567 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
566 568 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
567 569 exit 1
568 570 fi
569 571
570 572 # Don't clobber an old build
571 573 if [ -e "$BUILDDIR" ] ; then
572 574 echo "error: directory ${BUILDDIR} already exists, not proceeding"
573 575 exit 1
574 576 fi
575 577
576 578 # Setup chroot directory
577 579 mkdir -p "${R}"
578 580
579 581 # Check if build directory has enough of free disk space >512MB
580 582 if [ "$(df --output=avail "${BUILDDIR}" | sed "1d")" -le "524288" ] ; then
581 583 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
582 584 exit 1
583 585 fi
584 586
585 587 set -x
586 588
587 589 # Call "cleanup" function on various signals and errors
588 590 trap cleanup 0 1 2 3 6
589 591
590 592 # Add required packages for the minbase installation
591 593 if [ "$ENABLE_MINBASE" = true ] ; then
592 594 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
593 595 fi
594 596
595 597 # Add parted package, required to get partprobe utility
596 598 if [ "$EXPANDROOT" = true ] ; then
597 599 APT_INCLUDES="${APT_INCLUDES},parted"
598 600 fi
599 601
600 602 # Add dphys-swapfile package, required to enable swap
601 603 if [ "$ENABLE_DPHYSSWAP" = true ] ; then
602 604 APT_INCLUDES="${APT_INCLUDES},dphys-swapfile"
603 605 fi
604 606
605 607 # Add dbus package, recommended if using systemd
606 608 if [ "$ENABLE_DBUS" = true ] ; then
607 609 APT_INCLUDES="${APT_INCLUDES},dbus"
608 610 fi
609 611
610 612 # Add iptables IPv4/IPv6 package
611 613 if [ "$ENABLE_IPTABLES" = true ] ; then
612 614 APT_INCLUDES="${APT_INCLUDES},iptables,iptables-persistent"
613 615 fi
614 616 # Add apparmor for KERNEL_SECURITY
615 617 if [ "$KERNEL_SECURITY" = true ] ; then
616 618 APT_INCLUDES="${APT_INCLUDES},apparmor,apparmor-utils,apparmor-profiles,apparmor-profiles-extra,libapparmor-perl"
617 619 fi
618 620
619 621 # Add openssh server package
620 622 if [ "$SSH_ENABLE" = true ] ; then
621 623 APT_INCLUDES="${APT_INCLUDES},openssh-server"
622 624 fi
623 625
624 626 # Add alsa-utils package
625 627 if [ "$ENABLE_SOUND" = true ] ; then
626 628 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
627 629 fi
628 630
629 631 # Add rng-tools package
630 632 if [ "$ENABLE_HWRANDOM" = true ] ; then
631 633 APT_INCLUDES="${APT_INCLUDES},rng-tools"
632 634 fi
633 635
634 636 # Add fbturbo video driver
635 637 if [ "$ENABLE_FBTURBO" = true ] ; then
636 638 # Enable xorg package dependencies
637 639 ENABLE_XORG=true
638 640 fi
639 641
640 642 # Add user defined window manager package
641 643 if [ -n "$ENABLE_WM" ] ; then
642 644 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
643 645
644 646 # Enable xorg package dependencies
645 647 ENABLE_XORG=true
646 648 fi
647 649
648 650 # Add xorg package
649 651 if [ "$ENABLE_XORG" = true ] ; then
650 652 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
651 653 fi
652 654
653 655 # Replace selected packages with smaller clones
654 656 if [ "$ENABLE_REDUCE" = true ] ; then
655 657 ## Add levee package instead of vim-tiny
656 658 if [ "$REDUCE_VIM" = true ] ; then
657 659 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
658 660 fi
659 661
660 662 ## Add dropbear package instead of openssh-server
661 663 if [ "$REDUCE_SSHD" = true ] ; then
662 664 APT_INCLUDES="$(echo "${APT_INCLUDES}" | sed "s/openssh-server/dropbear/")"
663 665 fi
664 666 fi
665 667
666 668 # Configure systemd-sysv exclude to make halt/reboot/shutdown scripts available
667 669 if [ "$ENABLE_SYSVINIT" = false ] ; then
668 670 APT_EXCLUDES="--exclude=${APT_EXCLUDES},init,systemd-sysv"
669 671 fi
670 672
671 673 # Configure kernel sources if no KERNELSRC_DIR
672 674 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
673 675 KERNELSRC_CONFIG=true
674 676 fi
675 677
676 678 # Configure reduced kernel
677 679 if [ "$KERNEL_REDUCE" = true ] ; then
678 680 KERNELSRC_CONFIG=false
679 681 fi
680 682
681 683 # Configure qemu compatible kernel
682 684 if [ "$ENABLE_QEMU" = true ] ; then
683 685 DTB_FILE=vexpress-v2p-ca15_a7.dtb
684 686 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
685 687 KERNEL_DEFCONFIG="vexpress_defconfig"
686 688 if [ "$KERNEL_MENUCONFIG" = false ] ; then
687 689 KERNEL_OLDDEFCONFIG=true
688 690 fi
689 691 fi
690 692
691 693 # Execute bootstrap scripts
692 694 for SCRIPT in bootstrap.d/*.sh; do
693 695 head -n 3 "$SCRIPT"
694 696 . "$SCRIPT"
695 697 done
696 698
697 699 ## Execute custom bootstrap scripts
698 700 if [ -d "custom.d" ] ; then
699 701 for SCRIPT in custom.d/*.sh; do
700 702 . "$SCRIPT"
701 703 done
702 704 fi
703 705
704 706 # Execute custom scripts inside the chroot
705 707 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
706 708 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
707 709 chroot_exec /bin/bash -x <<'EOF'
708 710 for SCRIPT in /chroot_scripts/* ; do
709 711 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
710 712 $SCRIPT
711 713 fi
712 714 done
713 715 EOF
714 716 rm -rf "${R}/chroot_scripts"
715 717 fi
716 718
717 719 # Remove c/c++ build environment from the chroot
718 720 chroot_remove_cc
719 721
720 722 # Generate required machine-id
721 723 MACHINE_ID=$(dbus-uuidgen)
722 724 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
723 725 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
724 726
725 727 # APT Cleanup
726 728 chroot_exec apt-get -y clean
727 729 chroot_exec apt-get -y autoclean
728 730 chroot_exec apt-get -y autoremove
729 731
730 732 # Unmount mounted filesystems
731 733 umount -l "${R}/proc"
732 734 umount -l "${R}/sys"
733 735
734 736 # Clean up directories
735 737 rm -rf "${R}/run/*"
736 738 rm -rf "${R}/tmp/*"
737 739
738 740 # Clean up APT proxy settings
739 741 if [ "$KEEP_APT_PROXY" = false ] ; then
740 742 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
741 743 fi
742 744
743 745 # Clean up files
744 746 rm -f "${ETC_DIR}/ssh/ssh_host_*"
745 747 rm -f "${ETC_DIR}/dropbear/dropbear_*"
746 748 rm -f "${ETC_DIR}/apt/sources.list.save"
747 749 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
748 750 rm -f "${ETC_DIR}/*-"
749 751 rm -f "${ETC_DIR}/resolv.conf"
750 752 rm -f "${R}/root/.bash_history"
751 753 rm -f "${R}/var/lib/urandom/random-seed"
752 754 rm -f "${R}/initrd.img"
753 755 rm -f "${R}/vmlinuz"
754 756 rm -f "${R}${QEMU_BINARY}"
755 757
756 758 if [ "$ENABLE_QEMU" = true ] ; then
757 759 # Setup QEMU directory
758 760 mkdir "${BASEDIR}/qemu"
759 761
760 762 # Copy kernel image to QEMU directory
761 763 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
762 764
763 765 # Copy kernel config to QEMU directory
764 766 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
765 767
766 768 # Copy kernel dtbs to QEMU directory
767 769 for dtb in "${BOOT_DIR}/"*.dtb ; do
768 770 if [ -f "${dtb}" ] ; then
769 771 install_readonly "${dtb}" "${BASEDIR}/qemu/"
770 772 fi
771 773 done
772 774
773 775 # Copy kernel overlays to QEMU directory
774 776 if [ -d "${BOOT_DIR}/overlays" ] ; then
775 777 # Setup overlays dtbs directory
776 778 mkdir "${BASEDIR}/qemu/overlays"
777 779
778 780 for dtb in "${BOOT_DIR}/overlays/"*.dtbo ; do
779 781 if [ -f "${dtb}" ] ; then
780 782 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
781 783 fi
782 784 done
783 785 fi
784 786
785 787 # Copy u-boot files to QEMU directory
786 788 if [ "$ENABLE_UBOOT" = true ] ; then
787 789 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
788 790 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
789 791 fi
790 792 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
791 793 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
792 794 fi
793 795 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
794 796 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
795 797 fi
796 798 fi
797 799
798 800 # Copy initramfs to QEMU directory
799 801 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
800 802 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
801 803 fi
802 804 fi
803 805
804 806 # Calculate size of the chroot directory in KB
805 807 CHROOT_SIZE=$(expr "$(du -s "${R}" | awk '{ print $1 }')")
806 808
807 809 # Calculate the amount of needed 512 Byte sectors
808 810 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
809 811 FRMW_SECTORS=$(expr 128 \* 1024 \* 1024 \/ 512)
810 812 ROOT_OFFSET=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}")
811 813
812 814 # The root partition is EXT4
813 815 # This means more space than the actual used space of the chroot is used.
814 816 # As overhead for journaling and reserved blocks 35% are added.
815 817 ROOT_SECTORS=$(expr "$(expr "${CHROOT_SIZE}" + "${CHROOT_SIZE}" \/ 100 \* 35)" \* 1024 \/ 512)
816 818
817 819 # Calculate required image size in 512 Byte sectors
818 820 IMAGE_SECTORS=$(expr "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}")
819 821
820 822 # Prepare image file
821 823 if [ "$ENABLE_SPLITFS" = true ] ; then
822 824 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count="${TABLE_SECTORS}"
823 825 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek="${FRMW_SECTORS}"
824 826 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count="${TABLE_SECTORS}"
825 827 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek="${ROOT_SECTORS}"
826 828
827 829 ## Write firmware/boot partition tables
828 830 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
829 831 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
830 832 EOM
831 833
832 834 ## Write root partition table
833 835 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
834 836 ${TABLE_SECTORS},${ROOT_SECTORS},83
835 837 EOM
836 838
837 839 # Setup temporary loop devices
838 840 FRMW_LOOP="$(losetup -o 1M --sizelimit 128M -f --show "$IMAGE_NAME"-frmw.img)"
839 841 ROOT_LOOP="$(losetup -o 1M -f --show "$IMAGE_NAME"-root.img)"
840 842 # ENABLE_SPLITFS=false
841 843 else
842 844 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count="${TABLE_SECTORS}"
843 845 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek="${IMAGE_SECTORS}"
844 846
845 847 # Write partition table
846 848 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
847 849 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
848 850 ${ROOT_OFFSET},${ROOT_SECTORS},83
849 851 EOM
850 852
851 853 # Setup temporary loop devices
852 854 FRMW_LOOP="$(losetup -o 1M --sizelimit 128M -f --show "$IMAGE_NAME".img)"
853 855 ROOT_LOOP="$(losetup -o 129M -f --show "$IMAGE_NAME".img)"
854 856 fi
855 857
856 858 if [ "$ENABLE_CRYPTFS" = true ] ; then
857 859 # Create dummy ext4 fs
858 860 mkfs.ext4 "$ROOT_LOOP"
859 861
860 862 # Setup password keyfile
861 863 touch .password
862 864 chmod 600 .password
863 865 echo -n ${CRYPTFS_PASSWORD} > .password
864 866
865 867 # Initialize encrypted partition
866 868 cryptsetup --verbose --debug -q luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -h "${CRYPTFS_HASH}" -s "${CRYPTFS_XTSKEYSIZE}" .password
867 869
868 870 # Open encrypted partition and setup mapping
869 871 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
870 872
871 873 # Secure delete password keyfile
872 874 shred -zu .password
873 875
874 876 # Update temporary loop device
875 877 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
876 878
877 879 # Wipe encrypted partition (encryption cipher is used for randomness)
878 880 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count="$(blockdev --getsz "${ROOT_LOOP}")"
879 881 fi
880 882
881 883 # Build filesystems
882 884 mkfs.vfat "$FRMW_LOOP"
883 885 mkfs.ext4 "$ROOT_LOOP"
884 886
885 887 # Mount the temporary loop devices
886 888 mkdir -p "$BUILDDIR/mount"
887 889 mount "$ROOT_LOOP" "$BUILDDIR/mount"
888 890
889 891 mkdir -p "$BUILDDIR/mount/boot/firmware"
890 892 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
891 893
892 894 # Copy all files from the chroot to the loop device mount point directory
893 895 rsync -a "${R}/" "$BUILDDIR/mount/"
894 896
895 897 # Unmount all temporary loop devices and mount points
896 898 cleanup
897 899
898 900 # Create block map file(s) of image(s)
899 901 if [ "$ENABLE_SPLITFS" = true ] ; then
900 902 # Create block map files for "bmaptool"
901 903 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
902 904 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
903 905
904 906 # Image was successfully created
905 907 echo "$IMAGE_NAME-frmw.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
906 908 echo "$IMAGE_NAME-root.img ($(expr \( "${TABLE_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
907 909 else
908 910 # Create block map file for "bmaptool"
909 911 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
910 912
911 913 # Image was successfully created
912 914 echo "$IMAGE_NAME.img ($(expr \( "${TABLE_SECTORS}" + "${FRMW_SECTORS}" + "${ROOT_SECTORS}" \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
913 915
914 916 # Create qemu qcow2 image
915 917 if [ "$ENABLE_QEMU" = true ] ; then
916 918 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
917 919 QEMU_SIZE=16G
918 920
919 921 qemu-img convert -f raw -O qcow2 "$IMAGE_NAME".img "$QEMU_IMAGE".qcow2
920 922 qemu-img resize "$QEMU_IMAGE".qcow2 $QEMU_SIZE
921 923
922 924 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
923 925 fi
924 926 fi
1 NO CONTENT: file was removed, binary diff hidden
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant